package com.example.greenwatch;

import android.content.Intent;
import android.content.pm.PackageManager;
import android.os.Bundle;
import android.widget.Button;

import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;

public class MainActivity extends AppCompatActivity {
    private static final int RECHTEANFORDERUNG_KAMERA = 10;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Button kameraStarten = findViewById(R.id.button_camera);
        kameraStarten.setOnClickListener(v -> {
            if (istZugriffAufKameraErlaubt()) {
                starteKameraAktivitaet();
            } else {
                zugriffAufKameraAnfordern();
            }
        });
    }

    private boolean istZugriffAufKameraErlaubt() {
        return ContextCompat.checkSelfPermission(this, android.Manifest.permission.CAMERA) == PackageManager.PERMISSION_GRANTED;
    }

    private void zugriffAufKameraAnfordern() {
        ActivityCompat.requestPermissions(this,new String[]{android.Manifest.permission.CAMERA}, RECHTEANFORDERUNG_KAMERA);
    }

    private void starteKameraAktivitaet() {
        startActivity(new Intent(this, KameraAktivitaet.class));
    }
}